<?php

namespace Drupal\dynamic_queues\Plugin\Derivative;

use Drupal\Component\Plugin\Derivative\DeriverBase;
use Drupal\dynamic_queues\Controller\DynamicQueueController;

/**
 * The dynamic derivative Queue.
 */
class DynamicQueuesDerivative extends DeriverBase {
  /**
   * {@inheritdoc}
   */

  /**
   * Definitions for dynamic queue from parent.
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    $queue_name_lists = explode("|", \Drupal::config('dynamic_queues.settings_form')->get('multiple_queue_names'));

    if (count($queue_name_lists) > 0) {
      foreach ($queue_name_lists as $key => $value) {
        $totalQueues = DynamicQueueController::getQueueLength($value);
        for ($i = 0; $i <= $totalQueues; $i++) {
          $custom_queue = $value . "_queue_" . $i;
          $this->derivatives[$custom_queue] = $base_plugin_definition;
          $this->derivatives[$custom_queue]['title'] = $custom_queue . 'Queue';
        }
      }
    }
    \Drupal::service('plugin.manager.queue_worker')->clearCachedDefinitions();
    return $this->derivatives;
  }

}
